<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FmtOrdemServService;
use FM\Traits\TResponse;

class FmtOrdemServController
{
    use TResponse;
    protected $OrdemServService;

    public function __construct(FmtOrdemServService $OrdemServService)
    {
        $this->OrdemServService = $OrdemServService;
    }

    public function getOrdensServico(Request $request)
    {
        try {
            $data = $this->OrdemServService->getOrdensServico();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getComentariosOrdem(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $data = $this->OrdemServService->getComentariosOrdem($parametros);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveComentarioOrdem(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $this->OrdemServService->saveComentarioOrdem($parametros);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insertOrdemServico(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $this->OrdemServService->insertOrdemServico($parametros);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getHistoricoOrdemServ(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $data = $this->OrdemServService->getHistoricoOrdemServ($parametros);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    /* Rotina do Kanban */

    public function getDadosKanban(Request $request)
    {
        try {
            $data = $this->OrdemServService->getDadosKanban($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    /* Fim rotina do Kanban */

    public function getProfissionalExterno()
    {
        try {
            $data = $this->OrdemServService->getProfissionalExterno();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}
