CREATE OR REPLACE PROCEDURE INSERT_PRODCOMPCOMPL IS
BEGIN 
   LOOP
      INSERT INTO PRODCOMPCOMPL (NRPRODCOMPCOMPL, CDOPERADOR, CDPRODUTO, CDPRODCOMPL)
      SELECT SEQ_NRPRODCOMPCOMPL.NEXTVAL, PF.CDOPERADOR, PI.CDPRODUTO, PC.CDPRODUTO CDPRODCOMPL
        FROM PRODCOMP PF INNER JOIN PRODUTO PI ON PF.CDPRODUTO = PI.CDPRODUTO
                         INNER JOIN PRODUTO PC ON PC.CDARVPROD LIKE PI.CDARVPROD || '%'
       WHERE PC.CDPRODESTO IS NOT NULL
         AND NOT EXISTS (SELECT 1
                           FROM PRODCOMPCOMPL
                          WHERE PRODCOMPCOMPL.CDPRODCOMPL = PC.CDPRODUTO
                            AND PRODCOMPCOMPL.CDOPERADOR  = PF.CDOPERADOR);
         
      EXIT WHEN SQL%ROWCOUNT = 0;
      COMMIT;
   END LOOP;
   COMMIT;
END INSERT_PRODCOMPCOMPL;
/

BEGIN
   DECLARE
      V_COUNT NUMBER;
   BEGIN
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
            INTO V_COUNT
            FROM USER_SCHEDULER_JOBS
           WHERE JOB_NAME = 'JOB_INSERT_PRODCOMPCOMPL';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_INSERT_PRODCOMPCOMPL',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN INSERT_PRODCOMPCOMPL(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=HOURLY; BYMINUTE=0',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para realizar a inserir produtos na tabela PRODCOMPCOMPL.'
         );
      ELSE
         DBMS_SCHEDULER.DROP_JOB(JOB_NAME => 'JOB_INSERT_PRODCOMPCOMPL');
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_INSERT_PRODCOMPCOMPL',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN INSERT_PRODCOMPCOMPL(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=HOURLY; BYMINUTE=0',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para realizar a inserir produtos na tabela PRODCOMPCOMPL.'
         );
      END IF;
   END;
END;
/